/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.widget;
import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ContentValues;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.util.Log;
import android.widget.RemoteViews;

import net.micode.notes.R;
import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.tool.ResourceParser;
import net.micode.notes.ui.NoteEditActivity;
import net.micode.notes.ui.NotesListActivity;

// 继承自AppWidgetProvider，用于管理Note小部件的抽象类
public abstract class NoteWidgetProvider extends AppWidgetProvider {
    // 定义查询数据库时需要返回的列
    public static final String [] PROJECTION = new String [] {
        NoteColumns.ID,          // 笔记ID
        NoteColumns.BG_COLOR_ID, // 笔记背景颜色ID
        NoteColumns.SNIPPET     // 笔记摘要
    };

    // 定义PROJECTION数组中各列的索引，方便后续操作
    public static final int COLUMN_ID           = 0;
    public static final int COLUMN_BG_COLOR_ID  = 1;
    public static final int COLUMN_SNIPPET      = 2;

    // 用于日志输出的标签
    private static final String TAG = "NoteWidgetProvider";

    // 当小部件被删除时，更新数据库中对应的笔记，将WIDGET_ID设置为无效
    @Override
    public void onDeleted(Context context, int[] appWidgetIds) {
        // 创建ContentValues对象，用于更新数据库
        ContentValues values = new ContentValues();
        values.put(NoteColumns.WIDGET_ID, AppWidgetManager.INVALID_APPWIDGET_ID); // 设置WIDGET_ID为无效值
        // 遍历所有被删除的小部件ID
        for (int i = 0; i < appWidgetIds.length; i++) {
            // 更新数据库中对应小部件ID的笔记，将WIDGET_ID设置为无效
            context.getContentResolver().update(Notes.CONTENT_NOTE_URI,
                    values,
                    NoteColumns.WIDGET_ID + "=?",
                    new String[] { String.valueOf(appWidgetIds[i])});
        }
    }

    // 获取与小部件相关的笔记信息
    private Cursor getNoteWidgetInfo(Context context, int widgetId) {
        // 查询数据库，获取与小部件ID相关的笔记信息
        return context.getContentResolver().query(Notes.CONTENT_NOTE_URI,
                PROJECTION,
                NoteColumns.WIDGET_ID + "=? AND " + NoteColumns.PARENT_ID + "<>?",
                new String[] { String.valueOf(widgetId), String.valueOf(Notes.ID_TRASH_FOLER) },
                null);
    }

    // 更新小部件的显示内容，该方法被外部调用
    protected void update(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
        update(context, appWidgetManager, appWidgetIds, false); // 默认不开启隐私模式
    }

    // 更新小部件的显示内容，考虑隐私模式
    private void update(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds,
            boolean privacyMode) {
        // 遍历所有小部件ID
        for (int i = 0; i < appWidgetIds.length; i++) {
            // 如果小部件ID有效
            if (appWidgetIds[i] != AppWidgetManager.INVALID_APPWIDGET_ID) {
                // 获取默认背景ID
                int bgId = ResourceParser.getDefaultBgId(context);
                // 初始化笔记摘要为空字符串
                String snippet = "";
                // 创建意图，用于启动NoteEditActivity
                Intent intent = new Intent(context, NoteEditActivity.class);
                intent.setFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP); // 设置意图标志，确保Activity单实例
                intent.putExtra(Notes.INTENT_EXTRA_WIDGET_ID, appWidgetIds[i]); // 传递小部件ID
                intent.putExtra(Notes.INTENT_EXTRA_WIDGET_TYPE, getWidgetType()); // 传递小部件类型

                // 获取与小部件相关的笔记信息
                Cursor c = getNoteWidgetInfo(context, appWidgetIds[i]);
                if (c != null && c.moveToFirst()) {
                    // 如果查询结果有多条，记录错误日志并返回
                    if (c.getCount() > 1) {
                        Log.e(TAG, "Multiple message with same widget id:" + appWidgetIds[i]);
                        c.close();
                        return;
                    }
                    // 获取笔记摘要和背景ID
                    snippet = c.getString(COLUMN_SNIPPET);
                    bgId = c.getInt(COLUMN_BG_COLOR_ID);
                    intent.putExtra(Intent.EXTRA_UID, c.getLong(COLUMN_ID));
                    intent.setAction(Intent.ACTION_VIEW); // 设置意图动作为查看
                } else {
                    // 如果没有查询到笔记信息，设置默认文本和意图动作
                    snippet = context.getResources().getString(R.string.widget_havenot_content);
                    intent.setAction(Intent.ACTION_INSERT_OR_EDIT);
                }

                // 关闭游标
                if (c != null) {
                    c.close();
                }

                // 创建RemoteViews对象，用于更新小部件视图
                RemoteViews rv = new RemoteViews(context.getPackageName(), getLayoutId());
                // 设置背景图片资源
                rv.setImageViewResource(R.id.widget_bg_image, getBgResourceId(bgId));
                intent.putExtra(Notes.INTENT_EXTRA_BACKGROUND_ID, bgId);

                // 生成PendingIntent，用于启动宿主Activity
                PendingIntent pendingIntent = null;
                if (privacyMode) {
                    // 隐私模式下，显示默认文本，并启动笔记列表Activity
                    rv.setTextViewText(R.id.widget_text,
                            context.getString(R.string.widget_under_visit_mode));
                    pendingIntent = PendingIntent.getActivity(context, appWidgetIds[i], new Intent(
                            context, NotesListActivity.class), PendingIntent.FLAG_UPDATE_CURRENT);
                } else {
                    // 非隐私模式下，显示笔记摘要，并启动编辑笔记Activity
                    rv.setTextViewText(R.id.widget_text, snippet);
                    pendingIntent = PendingIntent.getActivity(context, appWidgetIds[i], intent,
                            PendingIntent.FLAG_UPDATE_CURRENT);
                }

                // 设置点击事件，点击小部件时启动对应的Activity
                rv.setOnClickPendingIntent(R.id.widget_text, pendingIntent);
                // 更新小部件视图
                appWidgetManager.updateAppWidget(appWidgetIds[i], rv);
            }
        }
    }

    // 获取背景图片资源ID的方法，需要子类实现
    protected abstract int getBgResourceId(int bgId);

    // 获取小部件布局资源ID的方法，需要子类实现
    protected abstract int getLayoutId();

    // 获取小部件类型的方法，需要子类实现
    protected abstract int getWidgetType();
}